with(Student[Calculus1]):
with(plots):
LimitEnUnPunt:= proc(f,x0,nm)
   local funcio,recta1,recta2,limit_esq,up_esq,limit_dre,up_dre,xmin,xmax,M,i;

   xmin:=x0-1:
   xmax:=x0+1:
 
   funcio:=plot(f(x),x=xmin-0.5..xmax+0.5,discont=true,color=green,thickness=4):
   recta1:=plot([[x0,limit(f(x),x=x0,left)],[x0,limit(f(x),x=x0,right)]], x=xmin..xmax,color=black,linestyle=3):
   recta2:=plot([[x0,0],[x0,limit(f(x),x=x0,right)]],x=xmin..xmax, color=black,linestyle=3):
   limit_esq:=plot([[x0-1/2^(n-1),f(x0-1/2^(n-1))] $n=1..nm],x=xmin..xmax,style=point,symbol=circle,color = red,symbolsize=10):
   up_esq:=plot([[[x0-1/2^(n-1),0],[x0-1/2^(n-1),f(x0-1/2^(n-1))]] $n=1..nm],x=xmin..xmax,color=red,linestyle=2):
   limit_dre:=plot([[x0+1/2^(n-1),f(x0+1/2^(n-1))] $n=1..nm],x=xmin..xmax,style=point,symbol=circle,color = blue,symbolsize=10):
   up_dre:=plot([[[x0+1/2^(n-1),0],[x0+1/2^(n-1),f(x0+1/2^(n-1))]] $n=1..nm],x=xmin..xmax,color=blue,linestyle=2):

   M:=matrix(nm+2,4,0);
   M[1,1]:=x;
   M[1,2]:=`f(x)`;
   M[1,3]:=x;
   M[1,4]:=`f(x)`;
   for i from 2 by 1 to nm+2 do
      M[i,1]:=evalf(x0-1/10^(i-1));
      M[i,3]:=evalf(x0+1/10^(i-1));
      M[i,2]:=evalf(f(M[i,1]));
      M[i,4]:=evalf(f(M[i,3]));
   od:
   print(display(funcio,recta1,recta2,limit_esq,limit_dre,up_esq,up_dre));
   print(M);   
 end:
TutorDeLimits:=proc(fx,x)
   LimitTutor(fx,x);
end:
with(plots):with(plottools):
biseccio_1pas := proc( f , x_esq , x_dret )
    local x;
 
    x := ( x_esq + x_dret )/2;
 
    if ( evalf(f(x_esq)*f(x)) <= 0 ) then
       [x_esq,x];
    else
       [x,x_dret];
    fi;
 end:
 biseccio := proc( f , x0_esq , x0_dret , tol )
    local x_esq , x_dret , x , X;
 
    if ( evalf(f(x0_esq)*f(x0_dret)) > 0 ) then
       print( `biseccio : ERROR en dades entrada` );
    fi;
 
    X := [x0_esq,x0_dret];
 
    x_esq := x0_esq;
    x_dret := x0_dret;
 
    while ( abs(evalf(f(x_esq))) > tol and abs(evalf(f(x_dret))) > tol ) do
       x:=biseccio_1pas( f , x_esq , x_dret );
       X := X , x;
       x_esq := x[1];
       x_dret := x[2];
    od;
 
    if ( abs(evalf(f(x_esq))) < tol) then
       X := X , [x_esq,x_esq];
    else
       X := X , [x_dret,x_dret];
    fi;
 end:
 biseccio_construct := proc(f,x0_esq,x0_dret,tol)
    local X,graf_f,p,x_esq,x_dret,p_esq,p_dret,up,down,x_mig,p_mig,
       lin_mig,p_esq_verd,p_dret_verd,p_base,i,r,f_p_esq,f_p_dret,f_p_mig,Xres;
 
    r:=min((x0_dret-x0_esq)*0.015,(f(x0_dret)-f(x0_esq))*0.015):
 
    X := [biseccio( f , x0_esq , x0_dret , tol)]:
 
    graf_f:=plot(f(x),x=x0_esq-1..x0_dret+1,colour=black,thickness=2):
    p[0]:=graf_f:
    x_esq:=X[1][1]:x_dret:=X[1][2]:
    p_esq:=plottools[disk]([x_esq,0],r,color=blue):
    p_dret:=plottools[disk]([x_dret,0],r,color=blue):
    p[1]:=plots[display]({p[0],p_esq,p_dret}):
    up := plot([[x_dret,0],[x_dret,f(x_dret)]],thickness=3,linestyle=3,color=blue):
    down := plot([[x_esq,0],[x_esq,f(x_esq)]],thickness=3,linestyle=3,color=blue):
    f_p_esq:=plottools[disk]([x_esq,f(x_esq)],r/2,color=blue):
    f_p_dret:=plottools[disk]([x_dret,f(x_dret)],r/2,color=blue):
 
    p[2]:=plots[display]({p[1],up,down,f_p_esq,f_p_dret}):
    x_mig:=(X[1][1]+X[1][2])/2:
    p_mig:=plottools[disk]([x_mig,0],r,color=red):
    f_p_mig:=plottools[disk]([x_mig,f(x_mig)],r/2,color=pink):
    p[3]:=plots[display]({p[2],p_mig}):
    lin_mig := plot([[x_mig,0],[x_mig,f(x_mig)]],thickness=3,linestyle=3,color=pink):
    p[4]:=plots[display]({p[3],lin_mig,f_p_mig}):
 
    p_esq_verd:=plottools[disk]([x_esq,0],r/2,color=green):
    p_dret_verd:=plottools[disk]([x_dret,0],r/2,color=green):
    p_base := plots[display]({graf_f,p_esq_verd,p_dret_verd}):
 
    for i from 2 to nops(X) do 
 
       x_esq:=X[i][1]:x_dret:=X[i][2]:
       p_esq:=plottools[disk]([x_esq,0],r,color=blue):
       p_dret:=plottools[disk]([x_dret,0],r,color=blue):
       p[4*(i-2)+5]:=plots[display]({p_base,p_esq,p_dret}):
       up := plot([[x_dret,0],[x_dret,f(x_dret)]],thickness=3,linestyle=3,color=blue):
       down := plot([[x_esq,0],[x_esq,f(x_esq)]],thickness=3,linestyle=3,color=blue):
       f_p_esq:=plottools[disk]([x_esq,f(x_esq)],r/2,color=blue):
       f_p_dret:=plottools[disk]([x_dret,f(x_dret)],r/2,color=blue):
       p[4*(i-2)+6]:=plots[display]({p[4*(i-2)+5],up,down,f_p_esq,f_p_dret}):
       x_mig:=(X[i][1]+X[i][2])/2:
       p_mig:=plottools[disk]([x_mig,0],r,color=red):
       f_p_mig:=plottools[disk]([x_mig,f(x_mig)],r/2,color=pink):
       p[4*(i-2)+7]:=plots[display]({p[4*(i-2)+6],p_mig}):
       lin_mig := plot([[x_mig,0],[x_mig,f(x_mig)]],thickness=3,linestyle=3,color=pink):
       p[4*(i-2)+8]:=plots[display]({p[4*(i-2)+7],lin_mig,f_p_mig}):
 
       p_esq_verd:=plottools[disk]([x_esq,0],r/2,color=green):
       p_dret_verd:=plottools[disk]([x_dret,0],r/2,color=green):
       p_base := plots[display]({p_base,p_esq_verd,p_dret_verd}):
 
    od:
 
    print(plots[display](seq( p[i], i = 0..4*(nops(X)-3)+8), insequence=true ));

    Xres:=matrix(nops(X),4);
    Xres[1,1]:=`x0`:Xres[1,2]:=`x1`:Xres[1,3]:=`f(x0)`:Xres[1,4]:=`f(x1)`;
    for i from 1 by 1 to nops(X)-1 do
       Xres[i+1,1]:=X[i][1]: Xres[i+1,2]:=X[i][2]:
       Xres[i+1,3]:=evalf(f(X[i][1])): Xres[i+1,4]:=evalf(f(X[i][2])):
    od:
    print(evalf(Xres));
    print([`x=`,X[nops(X)][1], `f(x)`= evalf(f(X[nops(X)][1])) ]);
 end:

# 
# 
# 
